<!-- Example widget for demonstration  -->
<script lang="ts">
	import { page } from '$app/stores';
	import { onMount } from 'svelte';
	import { streamerApi } from '$lib/requests/requests';
	import type { Streamer } from '$lib/api';

	// let streamerId = $page.url.searchParams.get('streamer');
	let streamerId: String | null = null;
	let streamer: Streamer | undefined;
	let isLoading = true;
	// random between 1 and 4
	let anonymous = false;

	onMount(async () => {
		streamerId = $page.url.searchParams.get('streamer');
		if (streamerId === "") streamerId = "-1";
		try {
			let resp = await streamerApi().getStreamerByIdStreamersStreamerIdGet(streamerId);
			streamer = resp.data;
		} catch (e) {
			if (streamerId !== null) {
				// Redirect to the sampe page without the streamer ID
				window.location.href = window.location.href.split('?')[0];
			}
		}
		isLoading = false;
	});

	let donsDeBase = [500, 1000, 2000, 5000];

	async function faireDon(montant: number) {
		if (isLoading) return;
		isLoading = true;

		// if url has /don/*, then * is the streamer name
		const requestBody = {
			amount: montant,
			streamer: streamerId ?? '-1',
			anonymous: anonymous
		};

		let dev_url = 'http://localhost:8080/';
		let prod_url = './';

		let url = process.env.NODE_ENV === 'development' ? dev_url : prod_url;

		const response = await fetch(url, {
			method: 'POST',
			headers: {
				'Content-Type': 'application/json'
			},
			body: JSON.stringify(requestBody)
		});

		if (response.ok) {
			isLoading = false;
			const responseData = await response.json();
			// Redirect to the URL sent by the backend
			window.location.href = responseData.redirectUrl;
		} else {
			console.error('Error submitting the form');
		}
	}

	function formatPrice(price: number) {
		return (price / 100).toFixed(2).replace('.', ',');
	}

	function parsePrice(price: string) {
		console.log(price);
		return parseInt((parseFloat(price.replace(',', '.')) * 100).toFixed(0));
	}
</script>

<!-- div in the center of the screen with form -->
<div class="flex flex-col items-center h-screen">
	{#if isLoading}
		<div class="absolute flex flex-col items-center w-full h-full rounded-md p-6">
			<!-- Add spinner in the middle -->
			<div class="flex flex-col items-center justify-center h-full">
				<div class="animate-spin rounded-full h-32 w-32 border-b-2 border-gray-900"></div>
				<p class="text-2xl font-bold mt-4">Chargement...</p>
			</div>
		</div>
	{/if}
	<div class="flex flex-col p-6 {isLoading ? 'blur-lg' : ''}">
		<h1 class="self-center text-3xl text-black font-bold mb-4">Faire un don</h1>

		<div class="warning self-center rounded-md p-2 mb-4">
			Attention :<br/>
			Sur HelloAsso un don par défaut à HelloAsso est ajouté. Vous pouvez le supprimer si vous souhaitez seulement faire un don au TN'Event.
		</div>

		<div class="self-center mb-4">
			<label for="anonymous" class="text-black select-none">Anonyme</label>
			<input
				type="checkbox"
				bind:checked={anonymous}
				id="anonymous"
				name="anonymous"
			/>
		</div>

		<div class="flex flex-col">
			<div class="grid grid-cols-2 gap-2">
				{#each donsDeBase as don}
					<button
						class="text-black rounded-md p-2 mb-2 min-h-12 max-h-12"
						on:click={() => {
							faireDon(don);
						}}
					>
						{formatPrice(don)} €
					</button>
				{/each}
			</div>

			<!-- montant personnalisé -->
			<h2 class="text-xl font-bold my-4 text-black self-start">Montant personnalisé :</h2>

			<div class="personnalized flex items-center">
				<div class="flex text-black rounded-md m-2 w-2/3">
					<input
						type="text"
						id="montant"
						class="grow text-black rounded-md text-right p-2 mr-2 min-h-12 max-h-12 placeholder:text-black"
						placeholder="0,00"
					/>
					<div class="self-center">€</div>
				</div>
				<button
					class="text-white rounded-md p-2 m-2 text-center w-1/3 min-h-12 max-h-12"
					on:click={() => {
						// @ts-ignore
						let p = parsePrice(document.getElementById('montant').value);

						if (p < 1) {
							alert('Le montant minimum est de 0.01€');
							return;
						} else if (p > 999999) {
							alert('Le montant maximum est de 9999,99€');
							return;
						} else if (isNaN(p)) {
							alert('Le montant doit être un nombre');
							return;
						}

						faireDon(p);
					}}>Envoyer</button
				>
			</div>
		</div>
	</div>
</div>

<!-- background to gray -->
<style>
	/* hsl(160, 48%, 43%), #00537e */
    /* hsl(160, 48%, 53%) */

	.warning {
		background-color: #e74c3c;
		color: white;

		--tw-shadow: 0 20px 25px -5px rgb(0 0 0 / .1), 0 8px 10px -6px rgb(0 0 0 / .1);
  		--tw-shadow-colored: 0 20px 25px -5px var(--tw-shadow-color), 0 8px 10px -6px var(--tw-shadow-color);
  		box-shadow: var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow);
	}

	button {
		background-color: #e7e2df;

		--tw-shadow: 0 20px 25px -5px rgb(0 0 0 / .1), 0 8px 10px -6px rgb(0 0 0 / .1);
  		--tw-shadow-colored: 0 20px 25px -5px var(--tw-shadow-color), 0 8px 10px -6px var(--tw-shadow-color);
  		box-shadow: var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow);
	}

	input[type="text"] {
		background-color: #e7e2df;

		--tw-shadow: 0 20px 25px -5px rgb(0 0 0 / .1), 0 8px 10px -6px rgb(0 0 0 / .1);
  		--tw-shadow-colored: 0 20px 25px -5px var(--tw-shadow-color), 0 8px 10px -6px var(--tw-shadow-color);
  		box-shadow: var(--tw-ring-offset-shadow, 0 0 #0000),var(--tw-ring-shadow, 0 0 #0000),var(--tw-shadow);
	}

	.personnalized button {
		background-color: hsl(160, 48%, 53%);
	}
	.personnalized button:hover {
		background-color: hsl(160, 48%, 43%);
	}

</style>
